<script lang="ts">
  import { page } from '$app/stores';
  import Accordion from '@svelte-ui/accordion/Accordion.svelte';
  import { onDestroy } from 'svelte';
  import DropDownArrow from '~/components/select/DropDownArrow.svelte';
  import { footerLinks } from '~/constants/footer-links.js';

  const { resources, supports, terms } = footerLinks.sub;
  const isOpened = [false, false, false];

  const unsubscribe = page.subscribe((data) => {
    isOpened.forEach((bool, idx) => {
      isOpened[idx] = false;
    });
  });

  onDestroy(() => {
    unsubscribe();
  });

  const onToggle = (idx: number, data: Record<string, string>) => {
    isOpened.forEach((bool, ix) => {
      if (ix === idx) {
        isOpened[idx] = data.detail.isOpen;
      } else isOpened[ix] = false;
    });
  };
</script>

<div class="sitemap-container">
  <div>
    <Accordion
      on:toggle={onToggle.bind(null, 0)}
      open={isOpened[0]}>
      <div
        slot="accordion-tab"
        class="tab">
        <h4>{resources.label}</h4>
        <DropDownArrow
          open={isOpened[0]}
          size={20}
          color={'black'} />
      </div>
      <ul slot="accordion-content">
        {#each resources.links as link}
          <li>
            <a href={link.url}>{link.name}</a>
          </li>
        {/each}
      </ul>
    </Accordion>
  </div>
  <div>
    <Accordion
      on:toggle={onToggle.bind(null, 1)}
      open={isOpened[1]}>
      <div
        slot="accordion-tab"
        class="tab">
        <h4>{supports.label}</h4>
        <DropDownArrow
          open={isOpened[1]}
          size={20}
          color={'black'} />
      </div>
      <ul slot="accordion-content">
        {#each supports.links as link}
          <li>
            <a href={link.url}>{link.name}</a>
          </li>
        {/each}
      </ul>
    </Accordion>
  </div>
  <div>
    <Accordion
      on:toggle={onToggle.bind(null, 2)}
      open={isOpened[2]}>
      <div
        slot="accordion-tab"
        class="tab">
        <h4>{terms.label}</h4>
        <DropDownArrow
          open={isOpened[2]}
          size={20}
          color={'black'} />
      </div>
      <ul slot="accordion-content">
        {#each terms.links as link}
          <li>
            <a href={link.url}>{link.name}</a>
          </li>
        {/each}
      </ul></Accordion>
  </div>
</div>

<style lang="postcss">
  .sitemap-container {
    & > div {
      &:not(:last-child) {
        border-bottom: var(--footer-separator);
      }

      width: 100%;
    }
  }

  .tab {
    display: flex;
    justify-content: space-between;
    padding: 10px var(--content-margin);
    padding-block: 5px;

    img {
      width: 20px;
      transform: rotate(90deg);
      transition: transform 0.3s ease;

      &.open {
        transform: rotate(-90deg);
      }
    }
  }

  ul {
    padding: calc(var(--content-margin) / 2) var(--content-margin) var(--content-margin);
    background-color: white;
  }
</style>
